var dom = (document.getElementsByTagName) ? true : false;
var ie5 = (document.getElementsByTagName && document.all) ? true : false;
var arrowUp, arrowDown;

if (ie5 || dom) 
	initSortTable();

function initSortTable() {
	arrowUp = document.createElement("SPAN");
	var tn = document.createTextNode("5");
	arrowUp.appendChild(tn);
	arrowUp.className = "arrow";

	arrowDown = document.createElement("SPAN");
	var tn = document.createTextNode("6");
	arrowDown.appendChild(tn);
	arrowDown.className = "arrow";
}
currentCol = 0
previousCol = -1

function CompareAlpha(a, b) {
	if (a[currentCol] < b[currentCol]) { return -1; }
	if (a[currentCol] > b[currentCol]) { return 1; }
	return 0;
}

function CompareAlphaIgnore(a, b) {
	strA = a[currentCol].toLowerCase();
	strB = b[currentCol].toLowerCase();
	if (strA < strB) { return -1; }
	else {
		if (strA > strB) { return 1; }
		else { return 0; }
	}
}

function CompareDate(a, b) {
	// this one works with date formats conforming to Javascript specifications, e.g. m/d/yyyy
	datA = new Date(a[currentCol]);
	datB = new Date(b[currentCol]);
	if (datA < datB) { return -1; }
	else {
		if (datA > datB) { return 1; }
		else { return 0; }
	}
}

function CompareDateEuro(a, b) {
	// this one works with european date formats, e.g. d.m.yyyy
	strA = a[currentCol].split(".");
	strB = b[currentCol].split(".")
	datA = new Date(strA[2], strA[1], strA[0]);
	datB = new Date(strB[2], strB[1], strB[0]);
	if (datA < datB) { return -1; }
	else {
		if (datA > datB) { return 1; }
		else { return 0; }
	}
}

function CompareNumeric(a, b) {
	//window.alert ("CompareNumeric");
	numA = a[currentCol]
	numB = b[currentCol]
	if (isNaN(numA)) { return 0;}
	else {
		if (isNaN(numB)) { return 0; }
		else { return numA - numB; }
	}
}

function ConvertToBytes(fileSize)
{
 var sBytes = "";
 sBytes = fileSize;
 var iBytes = 0;
 if (sBytes != "")
 {
  if (sBytes.match("bytes") == "bytes")
  {
   sBytes = sBytes.replace(" bytes", "");
   iBytes = parseFloat(sBytes)
  }
  else if (sBytes.match("Kb") == "Kb")
  {
   sBytes = sBytes.replace(" Kb", "");
   iBytes = parseFloat(sBytes)
   //alert(iBytes);
   iBytes = iBytes * 1024;
  }
  else if (sBytes.match("MB") == "MB")
  {
   sBytes = sBytes.replace(" MB", "");
   iBytes = parseFloat(sBytes)
   iBytes = iBytes * 1048576;
  } 
  else if (sBytes.match("GB") == "GB")
  {
   sBytes = sBytes.replace(" GB", "");
   iBytes = parseFloat(sBytes)
   iBytes = iBytes * 1073741824;
  } 
  //alert(iBytes);
  return iBytes;

 }
 else
 {
	 iBytes = parseFloat(fileSize)
 	 return iBytes;
 }
}

function TableSort(myTable, myCol, myType, e) {
	var tmp = e.target ? e.target : e.srcElement;
	var tHeadParent = getParent(tmp, "THEAD");
	var el = getParent(tmp, "TD");
	//var newline = '\n';
	//var testbefore='';
	
	document.body.style.cursor = 'wait';
	if (tHeadParent == null)
		return;	
	if (el != null) {
		var p = el.parentNode;
		var i;

		// typecast to Boolean
		el._descending = !Boolean(el._descending);

		if (tHeadParent.arrow != null) {
			if (tHeadParent.arrow.parentNode != el) {
				tHeadParent.arrow.parentNode._descending = null;	//reset sort order		
			}
			tHeadParent.arrow.parentNode.removeChild(tHeadParent.arrow);
		}

		if (el._descending)
			tHeadParent.arrow = arrowUp.cloneNode(true);
		else
			tHeadParent.arrow = arrowDown.cloneNode(true);

		el.appendChild(tHeadParent.arrow);
        }
	// Create a two-dimensional array and fill it with the table's content
	var mySource = (document.all) ? document.all(myTable) : document.getElementById(myTable); // document.all(myTable);
	var myTable = (document.all) ? document.all(myTable) : document.getElementById(myTable);
	var myRows = mySource.rows.length;
	var myCols = mySource.rows(0).cells.length;
	if ((myTable.id == 'FileNames') && ((myCol == 4) || (myCol == 3)) )
	{
		currentCol = 2;
	}
	else
	{
		currentCol = myCol;
	}
	
	myArray = new Array(myRows)
		
	//alert('begin arrayfill');
	for (i=0; i < myRows; i++) {
		myArray[i] = new Array(myCols+myCols)
		for (j=0; j < myCols; j++) {
				if (myTable.id == 'FileNames')
				{
		            if (j == 2)
		            {
			            myArray[i][j] = ConvertToBytes(mySource.rows(i).cells(j).innerText); 
			            //alert(myArray[i][j] + '  '  + i + ',' + j);
			        }
			        else if (j == 3)
			        {
				        var str = mySource.rows(i).cells(j).innerText;
				        var val = -1;
				        str = str.replace('%', '');
				        val = parseInt(str);
				        myArray[i][j] = val;
			    	}
			        else
			        {myArray[i][j] = mySource.rows(i).cells(j).innerText;}
		            myArray[i][myCols+j] = mySource.rows(i).cells(j).innerHTML;
		            //alert(myArray[i][myCols+j]);
			    	//testbefore = testbefore + newline + myArray[i][j] + newline + myArray[i][myCols+j];
		    	}
		    	else if (myTable.id == 'MyComp')
		    	{
		    		if ((j == 3) || (j == 4) || (j == 5))
		    		{
		    			 myArray[i][j] = ConvertToBytes(mySource.rows(i).cells(j).innerText); 
		    		}
		    		else
			        {myArray[i][j] = mySource.rows(i).cells(j).innerText;}
		            myArray[i][myCols+j] = mySource.rows(i).cells(j).innerHTML;
		        }
			    else
			    {
			        {
				        myArray[i][j] = mySource.rows(i).cells(j).innerText;
				    }
			        myArray[i][myCols+j] = mySource.rows(i).cells(j).innerHTML;
				}
			    
		}
	}
	//alert('end arrayfill');
	//WriteToFile('outputbeforesort.txt', testbefore);
	//alert('begin sort');

	if (myCol == previousCol) {
		myArray.reverse(); // clicked the same column as previously - reverse the sort
	}
	else { // clicked on a new column - sort as indicated
		//alert(myType);	
		switch (myType) {
			case "a":
				myArray.sort(CompareAlpha);
				break;
			case "ai":
				myArray.sort(CompareAlphaIgnore);
				break;
			case "d":
				myArray.sort(CompareDate);
				break;
			case "de":
				myArray.sort(CompareDateEuro);
				break;
			case "n":
				myArray.sort(CompareNumeric);
				break;
			case "o":
				myArray.sort();
				break;
			default:
				myArray.sort(CompareNumeric);
		}
	}       

	var test='';
	// Re-write the table contents
	for (i=0; i < myRows; i++) {		
		for (j=0; j < myCols; j++) {
		     mySource.rows(i).cells(j).innerHTML = myArray[i][myCols+j];
		    //test = test + newline + myArray[i][j] + newline + myArray[i][myCols+j];
		}
	}        
	//WriteToFile('outputaftersort.txt', test);
	previousCol = myCol; // remember the current sort column for the next pass
	document.body.style.cursor = '';

	return 0;
}


function replace(str, from, to) {
           var i = str.indexOf(from);
           if (!from || !str || i == -1) return str;
           var newstr = str.substring(0, i) + to;
           if (i+from.length < str.length)
           newstr += replace(str.substring(i+from.length,str.length),from,to);
           return newstr;
}


function getParent(el, pTagName) {
	if (el == null) return null;
	else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase())	// Gecko bug, supposed to be uppercase
		return el;
	else
		return getParent(el.parentNode, pTagName);
}

function selectTests(chkAllTests)
{
var allChecked;
var count=0;
if (typeof chkAllTests == 'string') chkAllTests = document.getElementById(chkAllTests);
//alert(SelectTest.length);
//alert(chkAllTests.checked);
allChecked=chkAllTests.checked;
for (var i=0;i<SelectTest.length;i++) {
   SelectTest[i].checked = allChecked;
   if (SelectTest[i].checked == true) {
	count++;
   }

}

if (count > 0) {
document.getElementById('ViewLogFiles').disabled=false;
} else {
document.getElementById('ViewLogFiles').disabled=true;
}

}


function selectSingleTest(chkAllTests)
{
var allChecked = true;
var count=0;
if (typeof chkAllTests == 'string') chkAllTests = document.getElementById(chkAllTests);

//alert(SelectTest.length);

for (var i=0;i<SelectTest.length && allChecked==true ;i++) {
   if (SelectTest[i].checked == false) {
       allChecked = false;
   }
}
chkAllTests.checked = allChecked;
i=0;
for (var i=0;i<SelectTest.length;i++) {
   if (SelectTest[i].checked == true) {
	count=count+1;
   }
}

if (count > 0) {
document.getElementById('ViewLogFiles').disabled=false;
} else {
document.getElementById('ViewLogFiles').disabled=true;
}


}

function hideColumn (colIndex) {
  var table = document.all ? document.all.tablea :
              document.getElementById('tablea');
//  alert(table.rows[0].cells[colIndex].innerHTML); 
//  alert(table.rows[1].cells[colIndex].innerHTML);
  var headerID= "headerCol" + colIndex;
//  alert(headerID);
//  alert(document.all(headerID).innerHTML);

  for (var j=0; j < table.tHead.rows[0].cells.length; j++){
      if (table.tHead.rows[0].cells[j].innerText != '') {
         //alert('Before:' + table.tHead.rows[0].cells[j].innerHTML);
	 table.tHead.rows[0].cells[j].innerHTML = '<nobr><B>' + table.tHead.rows[0].cells[j].innerText + '</B></nobr>';
         //alert('After:' + table.tHead.rows[0].cells[j].innerHTML);
      }else{
	  //alert('changing chkall');
	  //tbl.tHead.rows[0].cells[j].innerHTML = '<input type="checkbox" name="SelectAllTests" id="chkAll" style="width:12px; height:12px;" OnClick="selectTests('chkAll')"/>';
      }
  } 

  for (var i=0; i < table.tBodies[0].rows.length; i++){
    for(var j=0; j < table.tBodies[0].rows[i].cells.length; j++){
      if (table.tBodies[0].rows[i].cells[j].innerText != '') {
	 table.tBodies[0].rows[i].cells[j].innerHTML = '<nobr>' + table.tBodies[0].rows[i].cells[j].innerText + '</nobr>';
         //alert(table.tBodies[0].rows[i].cells[j].innerHTML);
      }else{
	  //alert('changing chkall');
	  //tbl.tHead.rows[0].cells[j].innerHTML = '<input type="checkbox" name="SelectAllTests" id="chkAll" style="width:12px; height:12px;" OnClick="selectTests('chkAll')"/>';
      }
    }
  }

  for (var j=0; j < table.tFoot.rows[0].cells.length; j++){
      if (table.tFoot.rows[0].cells[j].innerText != '') {
        // alert('Before:' + table.tFoot.rows[0].cells[j].innerHTML);
	 table.tFoot.rows[0].cells[j].innerHTML = '<nobr><B>' + table.tFoot.rows[0].cells[j].innerText + '</B></nobr>';
         //alert('After:' + table.tFoot.rows[0].cells[j].innerHTML);
      }else{
	 // alert('changing chkall');
	  //tbl.tHead.rows[0].cells[j].innerHTML = '<input type="checkbox" name="SelectAllTests" id="chkAll" style="width:12px; height:12px;" OnClick="selectTests('chkAll')"/>';
      }
  } 

  for (var i=0; i < table.tHead.rows.length; i++) {
        //alert(table.tHead.rows.length);
	table.tHead.rows[i].cells[colIndex].style.display = 'none';
  }

  for (var r = 0; r < table.tBodies[0].rows.length; r++){
        //alert(table.tBodies[0].rows.length);
    	table.rows[r].cells[colIndex].style.display = 'none';
  }


  for (var j=0; j < table.tFoot.rows.length; j++) {
        //alert(table.tFoot.rows.length);
	table.tFoot.rows[j].cells[colIndex].style.display = 'none'

  }
  //alert('Calling CheckForScroll');
  //CheckForScroll('tablea',true, 300);
}

function showColumn (colIndex) {
  var table = document.all ? document.all.tablea :
              document.getElementById('tablea');
  for (var r = 0; r < table.rows.length; r++)
    table.rows[r].cells[colIndex].style.display = '';
//  CheckForScroll('tablea',true, 300);

}




///////////////////////////////////////////////////////////////////////
//     This Button Script was designed by Erik Arvidsson for WebFX   //
//                                                                   //
//     For more info and examples see: http://www.eae.net/webfx/     //
//     or send mail to erik@eae.net                                  //
//                                                                   //
//     Feel free to use this code as lomg as this disclaimer is      //
//     intact.                                                       //
///////////////////////////////////////////////////////////////////////

document.onmouseover = doOver;
document.onmouseout  = doOut;
document.onmousedown = doDown;
document.onmouseup   = doUp;


function doOver() {
	var toEl = getReal(window.event.toElement, "className", "coolButton");
	var fromEl = getReal(window.event.fromElement, "className", "coolButton");
	if (toEl == fromEl) return;
	var el = toEl;
	
//	alert(el);
	
//	var cDisabled = el.getAttribute("cDisabled");
	var cDisabled = el.cDisabled;
//	alert(cDisabled);
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present
	
	if (el.className == "coolButton")
		el.onselectstart = new Function("return false");
	
	if ((el.className == "coolButton") && !cDisabled) {
		makeRaised(el);
		makeGray(el,false);
	}
}

function doOut() {
	var toEl = getReal(window.event.toElement, "className", "coolButton");
	var fromEl = getReal(window.event.fromElement, "className", "coolButton");
	if (toEl == fromEl) return;
	var el = fromEl;

//	var cDisabled = el.getAttribute("cDisabled");
	var cDisabled = el.cDisabled;
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present

	var cToggle = el.cToggle;
	toggle_disabled = (cToggle != null); // If CTOGGLE atribute is present

	if (cToggle && el.value) {
		makePressed(el);
		makeGray(el,true);
	}
	else if ((el.className == "coolButton") && !cDisabled) {
		makeFlat(el);
		makeGray(el,true);
	}

}

function doDown() {
	el = getReal(window.event.srcElement, "className", "coolButton");
	
	var cDisabled = el.cDisabled;
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present
	
	if ((el.className == "coolButton") && !cDisabled) {
		makePressed(el)
	}
}

function doUp() {
	el = getReal(window.event.srcElement, "className", "coolButton");
	
	var cDisabled = el.cDisabled;
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present
	
	if ((el.className == "coolButton") && !cDisabled) {
		makeRaised(el);
	}
}


function getReal(el, type, value) {
	temp = el;
	while ((temp != null) && (temp.tagName != "BODY")) {
		if (eval("temp." + type) == value) {
			el = temp;
			return el;
		}
		temp = temp.parentElement;
	}
	return el;
}

function findChildren(el, type, value) {
	var children = el.children;
	var tmp = new Array();
	var j=0;
	
	for (var i=0; i<children.length; i++) {
		if (eval("children[i]." + type + "==\"" + value + "\"")) {
			tmp[tmp.length] = children[i];
		}
		tmp = tmp.concat(findChildren(children[i], type, value));
	}
	
	return tmp;
}

function disable(el) {

	if (document.readyState != "complete") {
		window.setTimeout("disable(" + el.id + ")", 100);	// If document not finished rendered try later.
		return;
	}
	
	var cDisabled = el.cDisabled;
	
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present

	if (!cDisabled) {
		el.cDisabled = true;
		
		el.innerHTML = '<span style="background: buttonshadow; width: 100%; height: 100%; text-align: center;">' +
						'<span style="filter:Mask(Color=buttonface) DropShadow(Color=buttonhighlight, OffX=1, OffY=1, Positive=0); height: 100%; width: 100%; text-align: center;">' +
						el.innerHTML +
						'</span>' +
						'</span>';
//
		if (el.onclick != null) {
			el.cDisabled_onclick = el.onclick;
			el.onclick = null;
		}
	}
}

function enable(el) {
	var cDisabled = el.cDisabled;
	
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present
	
	if (cDisabled) {
		el.cDisabled = null;
		el.innerHTML = el.children[0].children[0].innerHTML;

		if (el.cDisabled_onclick != null) {
			el.onclick = el.cDisabled_onclick;
			el.cDisabled_onclick = null;
		}
	}
}

function addToggle(el) {
	var cDisabled = el.cDisabled;
	
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present
	
	var cToggle = el.cToggle;
	
	cToggle = (cToggle != null); // If CTOGGLE atribute is present

	if (!cToggle && !cDisabled) {
		el.cToggle = true;
		
		if (el.value == null)
			el.value = 0;		// Start as not pressed down
		
		if (el.onclick != null)
			el.cToggle_onclick = el.onclick;	// Backup the onclick
		else 
			el.cToggle_onclick = "";

		el.onclick = new Function("toggle(" + el.id +"); " + el.id + ".cToggle_onclick();");
	}
}

function removeToggle(el) {
	var cDisabled = el.cDisabled;
	
	cDisabled = (cDisabled != null); // If CDISABLED atribute is present
	
	var cToggle = el.cToggle;
	
	cToggle = (cToggle != null); // If CTOGGLE atribute is present
	
	if (cToggle && !cDisabled) {
		el.cToggle = null;

		if (el.value) {
			toggle(el);
		}

		makeFlat(el);
		
		if (el.cToggle_onclick != null) {
			el.onclick = el.cToggle_onclick;
			el.cToggle_onclick = null;
		}
	}
}

function toggle(el) {
	el.value = !el.value;
	
	if (el.value)
		el.style.background = "URL(toolbar/tileback.gif)";
	else
		el.style.backgroundImage = "";

//	doOut(el);	
}


function makeFlat(el) {
	with (el.style) {
		background = "";
		border = "1px solid buttonface";
		padding      = "1px";
	}
}

function makeRaised(el) {
	with (el.style) {
		borderLeft   = "1px solid buttonhighlight";
		borderRight  = "1px solid buttonshadow";
		borderTop    = "1px solid buttonhighlight";
		borderBottom = "1px solid buttonshadow";
		padding      = "1px";
	}
}

function makePressed(el) {
	with (el.style) {
		borderLeft   = "1px solid buttonshadow";
		borderRight  = "1px solid buttonhighlight";
		borderTop    = "1px solid buttonshadow";
		borderBottom = "1px solid buttonhighlight";
		paddingTop    = "2px";
		paddingLeft   = "2px";
		paddingBottom = "0px";
		paddingRight  = "0px";
	}
}

function makeGray(el,b) {
/*	var filtval;
	
	if (b)
		filtval = "gray()";
	else
		filtval = "";

	var imgs = findChildren(el, "tagName", "IMG");
		
	for (var i=0; i<imgs.length; i++) {
		imgs[i].style.filter = filtval;
	}
*/
}
	

document.write("<style>");
document.write(".coolBar	{background: buttonface;border-top: 1px solid buttonhighlight;	border-left: 1px solid buttonhighlight;	border-bottom: 1px solid buttonshadow; border-right: 1px solid buttonshadow; padding: 2px; font: menu;}");
document.write(".coolButton {border: 1px solid buttonface; padding: 1px; text-align: center; cursor: default;}");
//document.write(".coolButton IMG	{filter: gray();}");
document.write("</style>");